Date Mon, 4 Mar 1996

Subject : Drawing Circles

This is a routine which uses second order differences to generate the
circle. Notice that this does not use any sin or cos functions.

Proc Circle[RADIUS,XC,YC,COLOR]

X=0
Y=RADIUS
D=1-RADIUS
DELTAE=3
DELTASE=-2*RADIUS + 5

Ink COLOR,,
Plot XC,YC+RADIUS
Plot XC,RADIUS,YC
Plot XC,YC-RADIUS
Plot XC+RADIUS,YC
While Y<X
        If D<0
             D=D+DELTAE
             DELTASE=DELTASE+2
             Inc X
        Else
             D=D+DELTASE
             DELTAE=DELTAE+2
             DELTASE=DELTASE+4
             Inc X
             Dec Y
    EndIf
Plot XC+X,YC+Y
Plot XC-X,YC+Y
Plot XC+X,YC-Y
Plot XC-X,YC-Y
Plot XC+Y,YC+X
Plot XC-Y,YC+X
Plot XC+Y,YC-X
Plot XC-Y,YC-X

Wend
END PROC

Notice that this employs 8 fold symmetry and can in fact be optimised
even further by keeping 8 sets of coordinates and incrementing or
decrementing them accordingly.
Robert Currie...
